package config

import (
	"fmt"
	"strings"

	"gitlab.bad-wolf.fr/optifur/config"
)

// Config hold the configuration of the service
type Config struct {
	Address           config.HTTPServerConfig `json:"address"`
	CaptchatConfig    config.FileRead         `json:"captchatConfig"`
	CaptchatKey       *config.B64KeyFile      `json:"captchatKey"`
	FallbackLang      *string                 `json:"fallbackLang"`
	CaptchatSharedKey *config.B64KeyFile      `json:"captchatSharedKey"`
}

// String implements the stringer interfaces
func (c Config) String() string {
	builder := strings.Builder{}

	builder.WriteString(fmt.Sprintf("Address: %s\n", c.Address))

	return builder.String()

}

var (
	cfg = &Config{}
)

// Load is a singleton function to load the configuration
func Load() *Config {

	config.Load(cfg)
	return cfg
}
