package challenge

import (
	"crypto/rand"
	"encoding/binary"
)

type CryptoSource struct {
}

func (_ CryptoSource) Int63() int64 {
	var b [8]byte
	_, err := rand.Read(b[:]) //nolint:gosec
	if err != nil {
		panic(err)
	}
	// mask off sign bit to ensure positive number
	return int64(binary.LittleEndian.Uint64(b[:]) & (1<<63 - 1))

}

func (_ CryptoSource) Seed(_ int64) {

}
